/**
 * 
 */
package com.hacktics.scip;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.InetSocketAddress;
import java.net.MalformedURLException;
import java.net.ProtocolException;
import java.net.Proxy;
import java.net.URL;
import java.net.URLEncoder;
import java.security.InvalidKeyException;
import java.util.jar.JarException;

/**
 * @author alex.mor
 *
 */
@SuppressWarnings("unused")
public class URLReader {

	public URLReader() {
		
	}
	
	public static String getURLResponse (String URL,Proxy proxy) {
		URL url = null;
		StringBuilder sb = new StringBuilder();
		
		try {
			url = new URL(URL);
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
		try {
			HttpURLConnection connection;
			if (proxy==null) {
				connection = (HttpURLConnection) url.openConnection();
			}
			else {
				connection = (HttpURLConnection) url.openConnection(proxy);	
			}
			
			HttpURLConnection.setFollowRedirects(true);
			
			//define a simple browser
			connection.setRequestProperty("User-Agent", "Mozilla/5.0 (compatible; MSIE 7.0)");
			connection.connect();
			BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
			String line = "";
			
			while ((line = in.readLine()) != null) {
				sb.append(line);
			}
			
			connection.disconnect();
			connection = null;
		} catch (IOException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		
		return sb.toString();
	}
	
	public static String postURLResponse (String URL, String PostParams,Proxy proxy) {
		URL url = null;
		StringBuilder sb = new StringBuilder();
		
		try {
			url = new URL(URL);
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
		try {
			//encode POST data
			//String encodedData = URLEncoder.encode( PostParams, "UTF-8");
			
			//create request
			//HttpURLConnection connection = (HttpURLConnection)url.openConnection();
			//Proxy proxy = new Proxy(Proxy.Type.HTTP, new InetSocketAddress("localhost", 8000));
			HttpURLConnection connection;
			if (proxy==null) {
				connection = (HttpURLConnection) url.openConnection();
			}
			else {
				connection = (HttpURLConnection) url.openConnection(proxy);	
			}
			
			HttpURLConnection.setFollowRedirects(true);
			connection.setRequestMethod("POST");
            connection.setRequestProperty( "Content-Type", "application/x-www-form-urlencoded" );
            connection.setRequestProperty( "Content-Length", Integer.toString(PostParams.length()) );
			//define a simple browser
			connection.setRequestProperty("User-Agent", "Mozilla/5.0 (compatible; MSIE 7.0)");
			connection.setDoOutput(true);
			
			//create POST data
			OutputStream os = connection.getOutputStream();
            os.write( PostParams.getBytes() );
            os.flush();
            os.close();
            
            sb.append(connection.getHeaderField(0));
			
			
			connection.disconnect();
			connection = null;
		} catch (IOException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		
		return sb.toString();
	}
	
	public static String getHost(String URL) {
		//assume starts with https/http
		if (URL.length()>7) {
			if (URL.indexOf("/", 9)>0) {
				URL = URL.substring(0, URL.indexOf("/", 9));
			}
			return URL.replaceAll("(?i)http://|https://", "");
		}
		return "";
	}

}
