package com.hacktics.scip.gui;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Dialog.ModalExclusionType;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.*;

public class ProxyView extends JDialog{

	/**
	 * 
	 */
	//private static final long serialVersionUID = 4789870787279482782L;
	
	private String proxyHost;
	public String getProxyHost() {
		return proxyHost;
	}
	public void setProxyHost(String proxyHost) {
		this.proxyHost = proxyHost;
	}
	
	private int proxyPort;
	public int getProxyPort() {
		return proxyPort;
	}
	public void setProxyPort(int proxyPort) {
		this.proxyPort = proxyPort;
	}
	
	private boolean useProxy = true;
	
	public boolean isUseProxy() {
		return useProxy;
	}
	public void setUseProxy(boolean useProxy) {
		this.useProxy = useProxy;
	}
	
	JPanel proxyPanel = new JPanel(new GridBagLayout()); 
	JCheckBox jCheckEnableProxy = new JCheckBox("Use Proxy Server",true);
	JLabel jLabelProxyHost = new JLabel("Host:");
	JLabel jLabelProxyPort = new JLabel("Port:");
	JTextField jTextProxyHost;
	JTextField jTextProxyPort;
	
	public ProxyView(boolean useProxy,String proxyHost,int proxyPort) {
		
		this.setUseProxy(useProxy);
		this.setProxyHost(proxyHost);
		this.setProxyPort(proxyPort);
		
		Container contentPane = this.getContentPane();
		initComponents (contentPane);
		setModal(true);
		setModalExclusionType(ModalExclusionType.APPLICATION_EXCLUDE);
				
		setTitle("Options");
		setPreferredSize(new Dimension(300, 120)); 
		setLocationRelativeTo(null);
		pack();
		setResizable(false);
		setVisible(true);
	}
	
	private void initComponents(Container contentPane)
    {
		proxyPanel.setBorder(BorderFactory.createTitledBorder("Proxy"));
		jCheckEnableProxy.addItemListener(new ItemListener() {
			
			@Override
			public void itemStateChanged(ItemEvent arg0) {
				jTextProxyHost.setEnabled(jCheckEnableProxy.isSelected());
				jTextProxyPort.setEnabled(jCheckEnableProxy.isSelected());
				jLabelProxyHost.setEnabled(jCheckEnableProxy.isSelected());
				jLabelProxyPort.setEnabled(jCheckEnableProxy.isSelected());
				setUseProxy(jCheckEnableProxy.isSelected());
				
			}
		});	
		//enable by default
		jCheckEnableProxy.setSelected(isUseProxy());
		
		jTextProxyHost = new JTextField(getProxyHost());
		jTextProxyHost.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				setProxyHost(jTextProxyHost.getText());
			}
		});
		
		jTextProxyPort = new JTextField(String.valueOf(getProxyPort()));
		jTextProxyPort.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					setProxyPort(Integer.parseInt(jTextProxyPort.getText()));
				}
				catch (Exception ex) {
					ex.printStackTrace();
				}
				
			}
		});
		
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(5,5,5,10);
		
		gbc.gridx=0;
		gbc.gridwidth=4;
		gbc.gridy=0;
		gbc.weightx = 0.2;
		proxyPanel.add(jCheckEnableProxy,gbc);
		gbc.gridwidth=1;
		gbc.gridx=0;
		gbc.gridy=1;
		gbc.weightx = 0.2;
		proxyPanel.add(jLabelProxyHost,gbc);
		gbc.gridx=1;
		gbc.weightx = 2;
		proxyPanel.add(jTextProxyHost,gbc);
		gbc.gridx=2;
		gbc.weightx = 0.2;
		proxyPanel.add(jLabelProxyPort,gbc);
		gbc.gridx=3;
		gbc.weightx = 1;
		proxyPanel.add(jTextProxyPort,gbc);
		contentPane.add(proxyPanel);
		
    }

}
