
/*

 */

package org.zaproxy.zap.extension.scip;

import com.hacktics.scip.SCIP;

import java.net.MalformedURLException;
import java.net.URL;
//import java.util.ResourceBundle;
//import java.util.Locale;
//import java.util.ResourceBundle;

import javax.swing.JMenuItem;

import org.parosproxy.paros.Constant;
import org.parosproxy.paros.extension.ExtensionAdaptor;
import org.parosproxy.paros.extension.ExtensionHook;
import org.parosproxy.paros.model.Model;

/*
 * This class is defines the extension.
 */
public class SCIPExtension extends ExtensionAdaptor {

    private JMenuItem mnuControlEvents = null;
    private RightClickSCIP popupMsgControlEvents = null;
    //private ResourceBundle messages = null;

 
   
    public SCIPExtension() {
        super();
        initialize();

    }

    /**
     * @param name
     */
    public SCIPExtension(String name) {
        super(name);
    }

        /**
         * This method initializes this
         * 
         * @return void
         */
        private void initialize() {
        this.setName("SCIP");
               
        }
        
        @Override
        public void hook(ExtensionHook extensionHook) {
            super.hook(extensionHook);
            
            if (getView() != null) {
                // Register our top menu item, as long as we're not running as a daemon
                // Use one of the other methods to add to a different menu list
                extensionHook.getHookMenu().addToolsMenuItem(getmnuSCIP());
        	    	// Register our popup menu item, as long as we're not running as a daemon
        	    	extensionHook.getHookMenu().addPopupMenuItem(getPopupControlEvents());
        	    }
        }


        private JMenuItem getmnuSCIP() {
        if (mnuControlEvents == null) {
                mnuControlEvents = new JMenuItem();
                mnuControlEvents.setText("SCIP");

                mnuControlEvents.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                        // This is where you do what you want to do.
                        // In this case we'll just show a popup message.
                	try {
	                		new SCIP(null);
	                	}
	                	catch (Exception ex) {
	                		System.out.println(ex.getMessage());
	                	}
                	}
                });
        	}
        	return mnuControlEvents;
        }
        
        private RightClickSCIP getPopupControlEvents() {
    		if (popupMsgControlEvents  == null) {
    			popupMsgControlEvents = new RightClickSCIP("SCIP - Control Event Enumeration");
    			popupMsgControlEvents.setExtension(this);
    		}
    		return popupMsgControlEvents;
    	}

        public String getMessageString (String key) {

    	        return key;
        }
        @Override
        public String getAuthor() {
                return "Hacktics";
        }

        @Override
        public String getDescription() {
                return "Server Control Invisibility Purge, by Hacktics";
        }

        @Override
        public URL getURL() {
                try {
                        return new URL(Constant.ZAP_EXTENSIONS_PAGE);
                } catch (MalformedURLException e) {
                        return null;
                }
        }
}